## castxml 0.6.2

=== test/CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================

# Keep test binaries away from main binaries.
unset(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
unset(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
unset(CMAKE_ARCHIVE_OUTPUT_DIRECTORY)

find_package(LibXml2 QUIET)

macro(castxml_test_cmd test)
  set(command $<TARGET_FILE:castxml> ${ARGN})
  set(_castxml_expect ${castxml_test_cmd_expect} cmd.${test})
  add_test(
    NAME cmd.${test}
    COMMAND ${CMAKE_COMMAND}
    "-Dcommand:STRING=${command}"
    "-Dexpect=${_castxml_expect}"
    ${castxml_test_cmd_extra_arguments}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/run.cmake
    )
endmacro()

macro(castxml_test_output_common prefix ext std test)
  if(DEFINED castxml_test_output_custom_start)
    set(_castxml_start ${castxml_test_output_custom_start})
  else()
    set(_castxml_start --castxml-start start)
  endif()
  if(castxml_test_output_custom_input)
    set(_castxml_input ${castxml_test_output_custom_input})
  else()
    set(_castxml_input ${test})
  endif()
  set(_castxml_expect ${prefix}.${std}.${test})
  if("${std}" MATCHES "^gnu(.*)$")
    list(APPEND _castxml_expect ${prefix}.c${CMAKE_MATCH_1}.${test})
  endif()
  if("${std}" MATCHES "^(c|gnu)[^+]")
    list(APPEND _castxml_expect ${prefix}.c.${test})
  endif()
  list(APPEND _castxml_expect ${prefix}.any.${test})

  if ("${prefix}" MATCHES "^gccxml(.*)$")
    set(flag --castxml-gccxml)
  elseif ("${prefix}" MATCHES "^castxml1(.*)$")
    set(flag --castxml-output=1)
  endif()

  set(std_flag -std=${std})
  if(LLVM_VERSION_MAJOR VERSION_LESS 5)
    if("${std_flag}" MATCHES "^(.*)17$")
      set(std_flag "${CMAKE_MATCH_1}1z")
    endif()
  endif()

  set(_schema "${CastXML_SOURCE_DIR}/doc/manual/castxml.xsd")

  set(command $<TARGET_FILE:castxml>
    ${flag}
    ${_castxml_start}
    ${std_flag}
    ${CMAKE_CURRENT_LIST_DIR}/input/${_castxml_input}.${ext}
    -o ${prefix}.${std}.${test}.xml
    ${castxml_test_output_extra_arguments}
    )
  add_test(
    NAME ${prefix}.${std}.${test}
    COMMAND ${CMAKE_COMMAND}
    "-Dcommand:STRING=${command}"
    "-Dexpect=${_castxml_expect}"
    "-Dxml=${prefix}.${std}.${test}.xml"
    "-Dxmllint=${LIBXML2_XMLLINT_EXECUTABLE}"
    "-Dschema=${_schema}"
    -P ${CMAKE_CURRENT_SOURCE_DIR}/run.cmake
    )
endmacro()

macro(castxml_test_output_c89 test)
  castxml_test_output_common(gccxml c c89 ${test})
  castxml_test_output_common(castxml1 c c89 ${test})
endmacro()

macro(castxml_test_output_c99 test)
  castxml_test_output_common(gccxml c c99 ${test})
  castxml_test_output_common(castxml1 c c99 ${test})
endmacro()

macro(castxml_test_output_c11 test)
  castxml_test_output_common(gccxml c c11 ${test})
  castxml_test_output_common(castxml1 c c11 ${test})
endmacro()

macro(castxml_test_output_gnu89 test)
  castxml_test_output_common(gccxml c gnu89 ${test})
  castxml_test_output_common(castxml1 c gnu89 ${test})
endmacro()

macro(castxml_test_output_gnu99 test)
  castxml_test_output_common(gccxml c gnu99 ${test})
  castxml_test_output_common(castxml1 c gnu99 ${test})
endmacro()

macro(castxml_test_output_gnu11 test)
  castxml_test_output_common(gccxml c gnu11 ${test})
  castxml_test_output_common(castxml1 c gnu11 ${test})
endmacro()

macro(castxml_test_output_cxx98 test)
  castxml_test_output_common(gccxml cxx c++98 ${test})
  castxml_test_output_common(castxml1 cxx c++98 ${test})
endmacro()

macro(castxml_test_output_gnuxx98 test)
  castxml_test_output_common(gccxml cxx gnu++98 ${test})
  castxml_test_output_common(castxml1 cxx gnu++98 ${test})
endmacro()

macro(castxml_test_output_cxx11 test)
  castxml_test_output_common(gccxml cxx c++11 ${test})
  castxml_test_output_common(castxml1 cxx c++11 ${test})
endmacro()

macro(castxml_test_output_gnuxx11 test)
  castxml_test_output_common(gccxml cxx gnu++11 ${test})
  castxml_test_output_common(castxml1 cxx gnu++11 ${test})
endmacro()

macro(castxml_test_output_cxx14 test)
  castxml_test_output_common(gccxml cxx c++14 ${test})
  castxml_test_output_common(castxml1 cxx c++14 ${test})
endmacro()

macro(castxml_test_output_gnuxx14 test)
  castxml_test_output_common(gccxml cxx gnu++14 ${test})
  castxml_test_output_common(castxml1 cxx gnu++14 ${test})
endmacro()

macro(castxml_test_output_cxx17 test)
  castxml_test_output_common(gccxml cxx c++17 ${test})
  castxml_test_output_common(castxml1 cxx c++17 ${test})
endmacro()

macro(castxml_test_output_gnuxx17 test)
  castxml_test_output_common(gccxml cxx gnu++17 ${test})
  castxml_test_output_common(castxml1 cxx gnu++17 ${test})
endmacro()

macro(castxml_test_output_cxx20 test)
  castxml_test_output_common(gccxml cxx c++20 ${test})
  castxml_test_output_common(castxml1 cxx c++20 ${test})
endmacro()

macro(castxml_test_output_gnuxx20 test)
  castxml_test_output_common(gccxml cxx gnu++20 ${test})
  castxml_test_output_common(castxml1 cxx gnu++20 ${test})
endmacro()

macro(castxml_test_output_broken_cxx98 test)
  castxml_test_output_common(gccxml.broken cxx c++98 ${test})
  castxml_test_output_common(castxml1.broken cxx c++98 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx98 test)
  castxml_test_output_common(gccxml.broken cxx gnu++98 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++98 ${test})
endmacro()

macro(castxml_test_output_broken_cxx11 test)
  castxml_test_output_common(gccxml.broken cxx c++11 ${test})
  castxml_test_output_common(castxml1.broken cxx c++11 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx11 test)
  castxml_test_output_common(gccxml.broken cxx gnu++11 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++11 ${test})
endmacro()

macro(castxml_test_output_broken_cxx14 test)
  castxml_test_output_common(gccxml.broken cxx c++14 ${test})
  castxml_test_output_common(castxml1.broken cxx c++14 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx14 test)
  castxml_test_output_common(gccxml.broken cxx gnu++14 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++14 ${test})
endmacro()

macro(castxml_test_output_broken_cxx17 test)
  castxml_test_output_common(gccxml.broken cxx c++17 ${test})
  castxml_test_output_common(castxml1.broken cxx c++17 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx17 test)
  castxml_test_output_common(gccxml.broken cxx gnu++17 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++17 ${test})
endmacro()

macro(castxml_test_output_broken_cxx20 test)
  castxml_test_output_common(gccxml.broken cxx c++20 ${test})
  castxml_test_output_common(castxml1.broken cxx c++20 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx20 test)
  castxml_test_output_common(gccxml.broken cxx gnu++20 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++20 ${test})
endmacro()

macro(castxml_test_output_c test)
  castxml_test_output_c89(${test})
  castxml_test_output_gnu89(${test})
  castxml_test_output_c99(${test})
  castxml_test_output_gnu99(${test})
  castxml_test_output_c11(${test})
  castxml_test_output_gnu11(${test})
endmacro()

macro(castxml_test_output test)
  castxml_test_output_cxx98(${test})
  castxml_test_output_gnuxx98(${test})
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_cxx20(${test})
    castxml_test_output_gnuxx20(${test})
  endif()
endmacro()

macro(castxml_test_output_11 test)
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_cxx20(${test})
    castxml_test_output_gnuxx20(${test})
  endif()
endmacro()

macro(castxml_test_output_14 test)
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_cxx20(${test})
    castxml_test_output_gnuxx20(${test})
  endif()
endmacro()

macro(castxml_test_output_14below test)
  castxml_test_output_cxx98(${test})
  castxml_test_output_gnuxx98(${test})
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
endmacro()

macro(castxml_test_output_broken test)
  castxml_test_output_broken_cxx98(${test})
  castxml_test_output_broken_gnuxx98(${test})
  castxml_test_output_broken_cxx11(${test})
  castxml_test_output_broken_gnuxx11(${test})
  castxml_test_output_broken_cxx14(${test})
  castxml_test_output_broken_gnuxx14(${test})
  castxml_test_output_broken_cxx17(${test})
  castxml_test_output_broken_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_broken_cxx20(${test})
    castxml_test_output_broken_gnuxx20(${test})
  endif()
endmacro()

set(input ${CMAKE_CURRENT_LIST_DIR}/input)
set(empty_c ${input}/empty.c)
set(empty_cxx ${input}/empty.cxx)
set(empty_m ${input}/empty.m)
set(empty_mm ${input}/empty.mm)

castxml_test_cmd(help1 -help)
castxml_test_cmd(help2 --help)
castxml_test_cmd(no-arguments)
castxml_test_cmd(version --version)

castxml_test_cmd(cc-missing --castxml-cc-gnu)
castxml_test_cmd(cc-option --castxml-cc-gnu -)
castxml_test_cmd(cc-paren-castxml --castxml-cc-gnu "(" --castxml-cc-msvc ")")
castxml_test_cmd(cc-paren-nested --castxml-cc-gnu "(" "(" ")" ")")
castxml_test_cmd(cc-paren-unbalanced --castxml-cc-gnu "(")
castxml_test_cmd(cc-twice --castxml-cc-msvc cl --castxml-cc-gnu gcc)
castxml_test_cmd(cc-unknown --castxml-cc-unknown cc)

castxml_test_cmd(gccxml-and-E --castxml-gccxml -E)
castxml_test_cmd(castxml-and-E --castxml-output=1 -E)

castxml_test_cmd(gccxml-twice --castxml-gccxml --castxml-gccxml)
castxml_test_cmd(castxml-twice --castxml-output=1 --castxml-output=1)

castxml_test_cmd(castxml-mix1 --castxml-gccxml --castxml-output=1)
castxml_test_cmd(castxml-mix2 --castxml-output=1 --castxml-gccxml)

castxml_test_cmd(castxml-wrong-epic-version --castxml-output=0)

castxml_test_cmd(gccxml-and-c99 --castxml-gccxml -std=c99 ${empty_c})
castxml_test_cmd(castxml-and-c99 --castxml-output=1 -std=c99 ${empty_c})

castxml_test_cmd(gccxml-and-c11 --castxml-gccxml -std=c11 ${empty_c})
castxml_test_cmd(castxml-and-c11 --castxml-output=1 -std=c11 ${empty_c})

castxml_test_cmd(gccxml-and-c++11 --castxml-gccxml -std=c++11 ${empty_cxx})
castxml_test_cmd(castxml-and-c++11 --castxml-output=1 -std=c++11 ${empty_cxx})

castxml_test_cmd(gccxml-and-c++14 --castxml-gccxml -std=c++14 ${empty_cxx})
castxml_test_cmd(castxml-and-c++14 --castxml-output=1 -std=c++14 ${empty_cxx})

if(LLVM_VERSION_MAJOR VERSION_LESS 5)
  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++1z ${empty_cxx})
  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++1z ${empty_cxx})
else()
  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++17 ${empty_cxx})
  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++17 ${empty_cxx})
endif()

if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
  castxml_test_cmd(gccxml-and-c++20 --castxml-gccxml -std=c++20 ${empty_cxx})

=== debian/changelog ===
castxml (0.6.2-2deepin1) unstable; urgency=medium

  * fix dependency: llvm 16

 -- Chang Yang <yangchang@deepin.org>  Thu, 23 Nov 2023 11:50:46 +0800

castxml (0.6.2-2) unstable; urgency=medium

  * d/rules: clean temporary manual page after install.
  * d/control: bump dependency from llvm 14 to 17.
    It has been considered to go for unversioned llvm packages, but at
    least one of them only included versioned variants. (Closes: #1055527)

 -- Étienne Mollier <emollier@debian.org>  Wed, 08 Nov 2023 08:54:59 +0100

castxml (0.6.2-1) unstable; urgency=medium

  * New upstream version 0.6.2
  * d/rules: stage manual page in debian/ directory. (Closes: #1043667)

 -- Étienne Mollier <emollier@debian.org>  Sat, 14 Oct 2023 19:21:45 +0200

=== debian/control ===
Source: castxml
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               help2man,
               libclang-16-dev,
               llvm-16-dev,
               libmlir-16-dev,
               mlir-16-tools,
               clang-tools-16,
               clang-format-16,
               clang-tidy-16,
               clangd-16,
               libedit-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/castxml
Vcs-Git: https://salsa.debian.org/med-team/castxml.git
Homepage: https://github.com/CastXML/CastXML
Rules-Requires-Root: no

Package: castxml
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C-family abstract syntax tree XML output tool
 Parse C-family source files and optionally write a subset of the
 Abstract Syntax Tree (AST) to a representation in XML.
 This is the successor to gccxml.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# clang pulls in atomics that require an extra library on armel
ifeq ($(DEB_HOST_ARCH),armel)
export DEB_LDFLAGS_MAINT_APPEND=-latomic
endif


CMAKE_FLAGS = -DCastXML_INSTALL_DOC_DIR:STRING=/usr/share/doc/castxml

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_installman:
	help2man debian/castxml/usr/bin/castxml \
		--name "Create an XML representation of C++ declarations" \
		--no-info \
	> debian/castxml.1
	dh_installman debian/castxml.1
	rm -vf debian/castxml.1

## castxml 0.6.3

=== CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================
cmake_minimum_required(VERSION 3.5)
project(CastXML)

include(src/Version.cmake)

include(CTest)

# Build tree locations.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/bin")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/lib")

# Install tree locations.
if(NOT CastXML_INSTALL_RUNTIME_DIR)
  set(CastXML_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT CastXML_INSTALL_DATA_DIR)
  set(CastXML_INSTALL_DATA_DIR share/castxml)
endif()
if(NOT CastXML_INSTALL_DOC_DIR)
  set(CastXML_INSTALL_DOC_DIR share/doc/castxml)
endif()
if(NOT CastXML_INSTALL_MAN_DIR)
  set(CastXML_INSTALL_MAN_DIR man)
endif()

macro(hint_clang_from_llvm)
  if(LLVM_DIR AND NOT Clang_DIR)
    if(LLVM_DIR MATCHES "share/llvm/cmake$")
      # LLVM/Clang 3.8 installs in <prefix>/share/{llvm,clang}/cmake
      get_filename_component(Clang_DIR "${LLVM_DIR}/../../clang/cmake" ABSOLUTE)
    else()
      # LLVM/Clang 3.9+ installs in <prefix>/lib/cmake/{llvm,clang}
      get_filename_component(Clang_DIR "${LLVM_DIR}/../clang" ABSOLUTE)
    endif()
  endif()
endmacro()

macro(hint_llvm_from_clang)
  if(Clang_DIR AND NOT LLVM_DIR)
    if(Clang_DIR MATCHES "share/clang/cmake$")
      # LLVM/Clang 3.8 installs in <prefix>/share/{llvm,clang}/cmake
      get_filename_component(LLVM_DIR "${Clang_DIR}/../../llvm/cmake" ABSOLUTE)
    else()
      # LLVM/Clang 3.9+ installs in <prefix>/lib/cmake/{llvm,clang}
      get_filename_component(LLVM_DIR "${Clang_DIR}/../llvm" ABSOLUTE)
    endif()
  endif()
endmacro()

# Build scripts may set either LLVM_DIR or Clang_DIR.
hint_llvm_from_clang()
hint_clang_from_llvm()

# If several LLVM versions provide CMake packages, try to use the latest one.
set(CMAKE_FIND_PACKAGE_SORT_ORDER NATURAL)
set(CMAKE_FIND_PACKAGE_SORT_DIRECTION DEC)

# Clang 3.8+ installs its own CMake package.  Try it first.
find_package(Clang QUIET)

# If Clang did not find LLVM for us, give our search below a hint.
hint_llvm_from_clang()

# Clang 3.9+ automatically searches for LLVM.  For older versions we
# may need to search for LLVM directly.  Either way we require LLVM.
if(NOT LLVM_FOUND)
  find_package(LLVM REQUIRED)
endif()

if(DEFINED LLVM_BUILD_BINARY_DIR)
  message(FATAL_ERROR
    "Clang_DIR or LLVM_DIR refers to a LLVM/Clang build directory:\n"
    "  Clang_DIR=${Clang_DIR}\n"
    "  LLVM_DIR=${LLVM_DIR}\n"
    "CastXML must be built against a LLVM/Clang install tree as "
    "specified in\n"
    "  ${CastXML_SOURCE_DIR}/README.rst")
endif()

set(found_clang 0)
set(tried_clang)
foreach(inc ${CLANG_INCLUDE_DIRS} ${LLVM_INCLUDE_DIRS})
  if(EXISTS "${inc}/clang/AST/ASTConsumer.h")
    set(found_clang 1)
    break()
  else()
    set(tried_clang "  ${inc}\n")
  endif()
endforeach()
if(NOT found_clang)
  message(FATAL_ERROR
    "Clang_DIR or LLVM_DIR refers to a LLVM/Clang installation:\n"
    "  Clang_DIR=${Clang_DIR}\n"
    "  LLVM_DIR=${LLVM_DIR}\n"
    "that does not have `clang/` headers in any include directory:\n"
    "${tried_clang}"
    )
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
  if(NOT LLVM_ENABLE_EH)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
  endif()
  if(NOT LLVM_ENABLE_RTTI)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
  endif()
endif()
if(CYGWIN OR MINGW)
  # Use GNU extensions on Windows as LLVM upstream does.
  set(CMAKE_CXX_EXTENSIONS ON)
else()
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()
if(LLVM_VERSION_MAJOR GREATER 15)
  set(CMAKE_CXX_STANDARD 17)
elseif(LLVM_VERSION_MAJOR GREATER 9)
  set(CMAKE_CXX_STANDARD 14)
else()
  set(CMAKE_CXX_STANDARD 11)
endif()

# Reserve ~10MB stack size on Windows, as LLVM upstream does.
if(MSVC)
  string(APPEND CMAKE_EXE_LINKER_FLAGS " -STACK:10000000")
endif()

add_definitions(${LLVM_DEFINITIONS})
include_directories(${CLANG_INCLUDE_DIRS})
include_directories(${LLVM_INCLUDE_DIRS})
link_directories(${LLVM_LIBRARY_DIRS})
if(NOT DEFINED LLVM_VERSION_PATCH)
  set(LLVM_VERSION_PATCH 0)
endif()

set(CLANG_RESOURCE_DIR "" CACHE PATH "Clang resource directory")
if(NOT CLANG_RESOURCE_DIR)
  set(v ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
  set(tried "")
  set(dirs "")
  foreach(d ${LLVM_LIBRARY_DIRS})
    # Clang resources are typically inside LLVM's library directory.
    list(APPEND dirs ${d})
    # Some distros use a layout of the form
    #     <prefix>/lib/llvm/<major-version>/lib
    #     <prefix>/lib/clang/<full-version>/include
    if("${d}" MATCHES "^(.*)/llvm/.*$")
      list(APPEND dirs "${CMAKE_MATCH_1}")
    endif()
  endforeach()
  # Look in each candidate directory for Clang resources.
  foreach(d ${dirs})
    if(IS_DIRECTORY "${d}/clang/${v}/include")
      set(CLANG_RESOURCE_DIR ${d}/clang/${v})
      break()
    elseif(IS_DIRECTORY "${d}/clang/${LLVM_VERSION_MAJOR}/include")
      set(CLANG_RESOURCE_DIR ${d}/clang/${LLVM_VERSION_MAJOR})
      break()
    endif()
    set(tried "${tried}\n  ${d}/clang/${v}")
  endforeach()
  if(NOT CLANG_RESOURCE_DIR)
    if(tried)
      set(tried "  Tried:${tried}")
    endif()
    message(FATAL_ERROR "Could not find CLANG_RESOURCE_DIR.${tried}"
      "\n"
      "Please set CLANG_RESOURCE_DIR to the Clang SDK directory containing "
      "\"include/stddef.h\", typically of the form \"<prefix>/lib/clang/${v}\"."
      )
  endif()
  unset(tried)
endif()

install(DIRECTORY ${CLANG_RESOURCE_DIR}/include
  DESTINATION "${CastXML_INSTALL_DATA_DIR}/clang"
  )

add_subdirectory(src)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

add_subdirectory(doc)

install(DIRECTORY share/castxml/ DESTINATION "${CastXML_INSTALL_DATA_DIR}")

install(FILES
  "LICENSE"
  "NOTICE"
  DESTINATION "${CastXML_INSTALL_DOC_DIR}"
  )

=== debian/changelog ===
castxml (0.6.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:36:23 +1100

castxml (0.6.3-1build1) noble; urgency=medium

  * No-change rebuild against libllvm17t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:08:13 +0000

castxml (0.6.3-1) unstable; urgency=medium

  * New upstream version 0.6.3
  * 0002-dont-install-license-file.patch: forward not-needed.
  * 0004_disable_msvc_test.patch: delete unused patch.
  * d/rules: do not build manuals on nodoc profile.
  * d/control: help2man unneeded on nodoc profile.

 -- Étienne Mollier <emollier@debian.org>  Sat, 20 Jan 2024 18:04:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: castxml
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Gert Wollny <gewo@debian.org>,
            Étienne Mollier <emollier@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               help2man,
-               libclang-16-dev,
-               llvm-16-dev,
-               libmlir-16-dev,
-               mlir-16-tools,
-               clang-tools-16,
-               clang-format-16,
-               clang-tidy-16,
-               clangd-16,
+               help2man <!nodoc>,
+               libclang-17-dev,
+               llvm-17-dev,
+               libmlir-17-dev,
+               mlir-17-tools,
+               clang-tools-17,
+               clang-format-17,
+               clang-tidy-17,
+               clangd-17,
                libedit-dev,
                zlib1g-dev
 Standards-Version: 4.6.2

=== debian/watch ===
version=4
opts="mode=git,dversionmangle=auto" \
	https://github.com/CastXML/CastXML.git \
	refs/tags/v?([\d\.\d]+)

## castxml 0.6.6

=== debian/changelog ===
castxml (0.6.6-1) unstable; urgency=medium

  * New upstream version 0.6.6
  * d/control: declare compliance to standards version 4.7.0.
  * 0002-dont-install-license-file.patch: unfuzz.

 -- Étienne Mollier <emollier@debian.org>  Sun, 26 May 2024 11:37:20 +0200

## castxml 0.6.8

=== debian/changelog ===
castxml (0.6.8-2) unstable; urgency=medium

  * d/control: bump build dependencies to llvm 18.
    Among other things, this should resolve the build failure affecting
    arm64 specifically.

 -- Étienne Mollier <emollier@debian.org>  Wed, 21 Aug 2024 23:01:01 +0200

castxml (0.6.8-1) unstable; urgency=medium

  * New upstream version 0.6.8

 -- Étienne Mollier <emollier@debian.org>  Sun, 11 Aug 2024 15:55:52 +0200

=== debian/control ===
Source: castxml
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               help2man <!nodoc>,
               libclang-18-dev,
               llvm-18-dev,
               libmlir-18-dev,
               mlir-18-tools,
               clang-tools-18,
               clang-format-18,
               clang-tidy-18,
               clangd-18,
               libedit-dev,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/castxml
Vcs-Git: https://salsa.debian.org/med-team/castxml.git
Homepage: https://github.com/CastXML/CastXML
Rules-Requires-Root: no

Package: castxml
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C-family abstract syntax tree XML output tool
 Parse C-family source files and optionally write a subset of the
 Abstract Syntax Tree (AST) to a representation in XML.
 This is the successor to gccxml.

## castxml 0.6.10

=== debian/changelog ===
castxml (0.6.10-1) unstable; urgency=medium

  * New upstream version 0.6.10
  * 0002-dont-install-license-file.patch: add author and last-update.
    Adding the author makes the patch dep3 compliant.

 -- Étienne Mollier <emollier@debian.org>  Sat, 30 Nov 2024 18:40:42 +0100

## castxml 0.6.11

=== debian/changelog ===
castxml (0.6.11-1) unstable; urgency=medium

  * New upstream version 0.6.11
  * d/control: bump build dependencies to llvm-toolchain-19.

 -- Étienne Mollier <emollier@debian.org>  Sat, 15 Feb 2025 19:01:40 +0100

=== debian/control ===
--- 
+++ 
@@ -7,14 +7,14 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                help2man <!nodoc>,
-               libclang-18-dev,
-               llvm-18-dev,
-               libmlir-18-dev,
-               mlir-18-tools,
-               clang-tools-18,
-               clang-format-18,
-               clang-tidy-18,
-               clangd-18,
+               libclang-19-dev,
+               llvm-19-dev,
+               libmlir-19-dev,
+               mlir-19-tools,
+               clang-tools-19,
+               clang-format-19,
+               clang-tidy-19,
+               clangd-19,
                libedit-dev,
                zlib1g-dev
 Standards-Version: 4.7.0

## castxml 0.6.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 #=============================================================================
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 project(CastXML)
 
 include(src/Version.cmake)
@@ -120,6 +120,8 @@
   if(NOT LLVM_ENABLE_RTTI)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
   endif()
+elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
+  string(APPEND CMAKE_CXX_FLAGS " -Zc:preprocessor")
 endif()
 if(CYGWIN OR MINGW)
   # Use GNU extensions on Windows as LLVM upstream does.

=== src/CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================

# Tell executables in the build tree where to find the source tree.
configure_file(
  "SourceDir.txt.in"
  "${CastXML_BINARY_DIR}/CMakeFiles/castxmlSourceDir.txt" @ONLY
  )
# Tell executables in the build tree where to find Clang resources.
configure_file(
  "ClangResourceDir.txt.in"
  "${CastXML_BINARY_DIR}/CMakeFiles/castxmlClangResourceDir.txt" @ONLY
  )
# Configure version number for C++ code.
configure_file(
  "Version.h.in"
  "${CastXML_BINARY_DIR}/src/Version.h" @ONLY
  )

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(CLANG_LINK_CLANG_DYLIB)
  if(NOT TARGET clang-cpp)
    message(FATAL_ERROR "CLANG_LINK_CLANG_DYLIB requires a LLVM/Clang providing clang-cpp")
  endif()
  if(NOT LLVM_LINK_LLVM_DYLIB)
    message(FATAL_ERROR "CLANG_LINK_CLANG_DYLIB requires a LLVM/Clang built with LLVM_LINK_LLVM_DYLIB")
  endif()
  set(clang_libs clang-cpp)
else()
  set(clang_libs
    clangFrontend
    clangDriver
    clangSerialization
    clangParse
    clangSema
    clangAnalysis
    clangEdit
    clangAST
    clangLex
    clangBasic
    )
endif()

set(llvm_libs
  native
  option
  bitreader
  support
  ${LLVM_TARGETS_TO_BUILD}
  )

add_executable(castxml
  castxml.cxx

  Detect.cxx Detect.h
  Options.h
  Output.cxx Output.h
  RunClang.cxx RunClang.h
  Utils.cxx Utils.h
  )
if(LLVM_LINK_LLVM_DYLIB)
  set(USE_SHARED USE_SHARED)
endif()
llvm_config(castxml ${USE_SHARED} ${llvm_libs})
if(LLVM_VERSION_MAJOR GREATER 5)
  set(maybe_PRIVATE "PRIVATE")
else()
  set(maybe_PRIVATE "")
endif()
target_link_libraries(castxml ${maybe_PRIVATE} ${clang_libs})

set_property(SOURCE Utils.cxx APPEND PROPERTY COMPILE_DEFINITIONS
  "CASTXML_INSTALL_DATA_DIR=\"${CastXML_INSTALL_DATA_DIR}\"")
install(TARGETS castxml DESTINATION ${CastXML_INSTALL_RUNTIME_DIR})

=== debian/changelog ===
castxml (0.6.13-2) unstable; urgency=medium

  * Revert "d/control: bump to llvm 21 tool chain."
    This restores llvm 19 toolchain for building castxml.  This is done to
    preserve buildability on most Debian ports and mips64el.

 -- Étienne Mollier <emollier@debian.org>  Wed, 08 Oct 2025 20:08:53 +0200

castxml (0.6.13-1) unstable; urgency=medium

  * New upstream version 0.6.13
  * d/control: bump to llvm 21 tool chain.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/watch: convert to v5 Github template.

 -- Étienne Mollier <emollier@debian.org>  Mon, 06 Oct 2025 22:52:15 +0200

=== debian/control ===
--- 
+++ 
@@ -17,11 +17,10 @@
                clangd-19,
                libedit-dev,
                zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/castxml
 Vcs-Git: https://salsa.debian.org/med-team/castxml.git
 Homepage: https://github.com/CastXML/CastXML
-Rules-Requires-Root: no
 
 Package: castxml
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,11 @@
 	dh_auto_configure -- $(CMAKE_FLAGS)
 
 override_dh_installman:
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	help2man debian/castxml/usr/bin/castxml \
 		--name "Create an XML representation of C++ declarations" \
 		--no-info \
 	> debian/castxml.1
 	dh_installman debian/castxml.1
 	rm -vf debian/castxml.1
+endif

=== debian/watch ===
Version: 5

Template: Github
Owner: CastXML
Project: CastXML

## castxml 0.7.0

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -169,6 +169,16 @@
   castxml_test_output_common(castxml1 cxx gnu++20 ${test})
 endmacro()
 
+macro(castxml_test_output_cxx23 test)
+  castxml_test_output_common(gccxml cxx c++23 ${test})
+  castxml_test_output_common(castxml1 cxx c++23 ${test})
+endmacro()
+
+macro(castxml_test_output_gnuxx23 test)
+  castxml_test_output_common(gccxml cxx gnu++23 ${test})
+  castxml_test_output_common(castxml1 cxx gnu++23 ${test})
+endmacro()
+
 macro(castxml_test_output_broken_cxx98 test)
   castxml_test_output_common(gccxml.broken cxx c++98 ${test})
   castxml_test_output_common(castxml1.broken cxx c++98 ${test})
@@ -217,6 +227,16 @@
 macro(castxml_test_output_broken_gnuxx20 test)
   castxml_test_output_common(gccxml.broken cxx gnu++20 ${test})
   castxml_test_output_common(castxml1.broken cxx gnu++20 ${test})
+endmacro()
+
+macro(castxml_test_output_broken_cxx23 test)
+  castxml_test_output_common(gccxml.broken cxx c++23 ${test})
+  castxml_test_output_common(castxml1.broken cxx c++23 ${test})
+endmacro()
+
+macro(castxml_test_output_broken_gnuxx23 test)
+  castxml_test_output_common(gccxml.broken cxx gnu++23 ${test})
+  castxml_test_output_common(castxml1.broken cxx gnu++23 ${test})
 endmacro()
 
 macro(castxml_test_output_c test)
@@ -241,6 +261,10 @@
     castxml_test_output_cxx20(${test})
     castxml_test_output_gnuxx20(${test})
   endif()
+  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 17)
+    castxml_test_output_cxx23(${test})
+    castxml_test_output_gnuxx23(${test})
+  endif()
 endmacro()
 
 macro(castxml_test_output_11 test)
@@ -254,6 +278,10 @@
     castxml_test_output_cxx20(${test})
     castxml_test_output_gnuxx20(${test})
   endif()
+  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 17)
+    castxml_test_output_cxx23(${test})
+    castxml_test_output_gnuxx23(${test})
+  endif()
 endmacro()
 
 macro(castxml_test_output_14 test)
@@ -264,6 +292,10 @@
   if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
     castxml_test_output_cxx20(${test})
     castxml_test_output_gnuxx20(${test})
+  endif()
+  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 17)
+    castxml_test_output_cxx23(${test})
+    castxml_test_output_gnuxx23(${test})
   endif()
 endmacro()
 
@@ -289,6 +321,10 @@
     castxml_test_output_broken_cxx20(${test})
     castxml_test_output_broken_gnuxx20(${test})
   endif()
+  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 17)
+    castxml_test_output_broken_cxx23(${test})
+    castxml_test_output_broken_gnuxx23(${test})
+  endif()
 endmacro()
 
 set(input ${CMAKE_CURRENT_LIST_DIR}/input)
@@ -316,30 +352,3 @@
 castxml_test_cmd(gccxml-twice --castxml-gccxml --castxml-gccxml)
 castxml_test_cmd(castxml-twice --castxml-output=1 --castxml-output=1)
 
-castxml_test_cmd(castxml-mix1 --castxml-gccxml --castxml-output=1)
-castxml_test_cmd(castxml-mix2 --castxml-output=1 --castxml-gccxml)
-
-castxml_test_cmd(castxml-wrong-epic-version --castxml-output=0)
-
-castxml_test_cmd(gccxml-and-c99 --castxml-gccxml -std=c99 ${empty_c})
-castxml_test_cmd(castxml-and-c99 --castxml-output=1 -std=c99 ${empty_c})
-
-castxml_test_cmd(gccxml-and-c11 --castxml-gccxml -std=c11 ${empty_c})
-castxml_test_cmd(castxml-and-c11 --castxml-output=1 -std=c11 ${empty_c})
-
-castxml_test_cmd(gccxml-and-c++11 --castxml-gccxml -std=c++11 ${empty_cxx})
-castxml_test_cmd(castxml-and-c++11 --castxml-output=1 -std=c++11 ${empty_cxx})
-
-castxml_test_cmd(gccxml-and-c++14 --castxml-gccxml -std=c++14 ${empty_cxx})
-castxml_test_cmd(castxml-and-c++14 --castxml-output=1 -std=c++14 ${empty_cxx})
-
-if(LLVM_VERSION_MAJOR VERSION_LESS 5)
-  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++1z ${empty_cxx})
-  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++1z ${empty_cxx})
-else()
-  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++17 ${empty_cxx})
-  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++17 ${empty_cxx})
-endif()
-
-if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
-  castxml_test_cmd(gccxml-and-c++20 --castxml-gccxml -std=c++20 ${empty_cxx})

=== debian/changelog ===
castxml (0.7.0-1) unstable; urgency=medium

  * New upstream version 0.7.0

 -- Étienne Mollier <emollier@debian.org>  Tue, 03 Mar 2026 18:30:35 +0100

castxml (0.6.13-3) unstable; urgency=medium

  * Reapply "d/control: bump to llvm 21 tool chain." (Closes: #1124057)
  * d/control: drop redundant Priority: optional.
  * d/control: declare compliance to standards version 4.7.3.

 -- Étienne Mollier <emollier@debian.org>  Tue, 30 Dec 2025 19:45:58 +0100
